        output "dibujo.bin"   ; debemos de poner esta instrucción o nos generaría un archivo.out, ponle espacios al principio
        
                    ; MSX-1 BIOS subrutines
                    ; Definiciones de subrutinas creadas para la bios 
                    ; http://map.grauw.nl/resources/msxbios.php
        
CHGET equ #009F    ; Se queda esperando que se pulse una tecla                            
CHGMOD equ #005F   ; Cambia el modo de screen pero previamente necesita que se le asigne el modo en el registro a
RDVDP equ #013E    ; Lee el registro de estado del vdp y lo mete en el resgistro a del z80
WRTVDP equ #0047   ; Escribe datos en un registro del VDP que previamente se le ha dicho o puesto en el registro c del z80, en el registro b del z80 se podrá el valor de los nuevos datos
LDIRVM equ #005C   ;Tansfiere bloques de la RAM a la VRAM, es la más importante, necesita previamente asignar valor al registro bc con la longitud, dc con la dirección de inicio de la VRAM y hl con la dirección de inicio de la RAM:
LDIRMV equ #0059   ; lo mismo que la anterior pero de VRAM->a RAM

    ; esto es oblgatorio para definir la cabecera de un archivo BIN
    ; https://www.faq.msxnet.org/suffix.html
    db   #fe              ; ID archivo binario, siempre hay que poner el mismo 0FEh
    dw   INICIO             ; dirección de inicio
    dw   FINAL              ; dirección final
    dw   MAIN               ; dircción del programa de ejecución (para cuando pongas r en bload"nombre_programa", r)
    
    org 33280               ; org se utiliza para decirle al z80 en que posición de memoria empieza nuestro programa (es la 33280 en decimal), en hezadecimal sería #8200   
INICIO:
 

MAIN:
     ;Cambiamos el modo de pantalla
    ld  a,2     ; La rutina CHGMOD nos obliga a poner en el registro a el modo de pantalla que queremos
    call CHGMOD ; Mira arriba, pone la explicación

;por favor antes de nada mira este dibujo: https://sites.google.com/site/multivac7/files-images/TMS9918_VRAMmap_G2_300dpi.png

;-----------------------------Tileset-------------------------------------------

    ;Cargamodo la parte superior de la pantalla (1 tileset)
    ld hl, tile1 ; la rutina LDIRVM necesita haber cargado previamente la dirección de inicio de la RAM, para saber porqué he puesto 0000 fíjate este dibujo https://sites.google.com/site/multivac7/files-images/TMS9918_VRAMmap_G2_300dpi.png ,así es como está formado el VDP en screen 2
    ld de, #0000 ; la rutina necesita haber cargado previamente con de la dirección de inicio de la VRAM          
    ld bc, 8*4; le decimos que nos cargue en la VRAM los byte de tile1 (1 tile son 8 byte (que a su ves s8n 8 bites)), le ponemos * 4 para que cargue los demas tiles
    call  LDIRVM ; Mira arriba, pone la explicación

    ;Cargamodo los tileset de la zona central de la pantalla (2 tileset)
    ld hl, tile1 
    ld de, #0800 
    ld bc, 8*4; le ponemos por 4 porque queremos ver todos los tiles 
    call  LDIRVM 

    ;Cargamodo los tileset de la parte inferior de la pantalla (el 3 banco)
    ld hl, tile1 
    ld de, #1000
    ld bc, 8*4
    call  LDIRVM 

;--------------------------------Colores--------------------------------------

    ;Cargando los colores de los tileset del 1 tercio de pantalla
    ld hl, tile1_color 
    ld de, #2000 
    ld bc, 8*4 ;le ponemos * 4 para que cargue los demas colores
    call  LDIRVM

    ;Cargando los colores de los tileset del 1 tercio de pantalla
    ld hl, tile1_color 
    ld de, #2800 
    ld bc, 8*4
    call  LDIRVM

    ;Cargando los colores de los tileset del 1 tercio de pantalla
    ld hl, tile1_color 
    ld de, #3000 
    ld bc, 8*4
    call  LDIRVM

;------------------------------Mapa-------------------------------

    ;Cargando los nombres de los patrones o tiles
    ld hl, mapa 
    ld de, #1800 
    ld bc, 32*24;32 tiles por 24 filas
    call  LDIRVM

    call CHGET
    ret


;Constantes
;colores
; 0 negro
; 1 violeta
; 2 verde oscuro
; 3 verde claro
; ------
; 7 azul
; 8 rojo 
; ------
; b amarillo en decimal 11

; los 8 bytes en la posicion 2000, es decir del 0000 al 0007 son para el primer tile, los 8 siguientes son para el 2 title, en este caso el tile_rojo, etc.
tile1: db #00,#00,#00,#00,#00,#00,#00,#00 ; la definición ahora no importa
tile_rojo: db #00,#00,#00,#00,#00,#00,#00,#00
tile_azul: db #00,#00,#00,#00,#00,#00,#00,#00
tile_amarillo: db #00,#00,#00,#00,#00,#00,#00,#00

; en tile1_color le hemos metido al 1 tile #08 que es 0000 1000, 1000=8 en decimal que en la paleta representa al rojo background y 0 que representa al negro foreground, coge la calculadora
; como coge el valor de la derecha (el background) al poner #0f, el f es el color 15 en decinal que en la paleta de colores es el blanco
tile1_color: db #08,#08,#08,#0f,#0f,#08,#08,#08  
tile_rojo_color: db #08,#08,#08,#08,#08,#08,#08,#08
tile_azul_color: db #07,#07,#07,#07,#07,#07,#07,#07
tile_amarillo_color: db #0b,#0b,#0b,#0b,#0b,#0b,#0b,#0b

                                                                                                                                        ;32 tiles de ancho=256 pixles
;En el mapa el tile1 sería el #00, el tile_rojo sería el #01, el tile_azul sería el #02, y el tile_amarillo sería el #03
mapa: db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02     
      db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02   
      db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02   
      db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02    
      db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02   
      db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02   
      db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02 
      db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02 
 
      
      db #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00  
      db #00,#00,#03,#00,#03,#00,#03,#03,#00,#03,#00,#03,#00,#00,#03,#03,#00,#03,#00,#00,#00,#03,#00,#00,#03,#03,#00,#00,#00,#03,#00,#00  
      db #00,#00,#03,#03,#03,#00,#03,#00,#00,#03,#00,#03,#00,#00,#03,#00,#00,#03,#00,#00,#03,#00,#03,#00,#03,#00,#03,#00,#03,#00,#03,#00  
      db #00,#00,#03,#03,#03,#00,#03,#00,#00,#03,#03,#03,#00,#00,#03,#00,#00,#03,#00,#00,#03,#03,#03,#00,#03,#03,#00,#00,#03,#00,#03,#00  
      db #00,#00,#03,#00,#03,#00,#03,#03,#00,#00,#03,#00,#00,#00,#03,#00,#00,#03,#00,#00,#03,#00,#03,#00,#03,#00,#00,#00,#03,#00,#03,#00  
      db #00,#00,#03,#00,#03,#00,#00,#03,#00,#00,#03,#00,#00,#00,#03,#00,#00,#03,#00,#00,#03,#00,#03,#00,#03,#03,#00,#00,#03,#00,#03,#00  
      db #00,#00,#03,#00,#03,#00,#00,#03,#00,#03,#00,#03,#00,#00,#03,#00,#00,#03,#00,#00,#03,#00,#03,#00,#03,#00,#03,#00,#03,#00,#03,#00  
      db #00,#00,#03,#00,#03,#00,#03,#03,#00,#03,#00,#03,#00,#00,#03,#03,#00,#03,#03,#00,#03,#00,#03,#00,#03,#00,#03,#00,#00,#03,#00,#00  

      db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02     
      db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02   
      db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02   
      db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02    
      db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02   
      db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02   
      db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02 
      db #02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02,#02    
      
                                                                                                                                        ;son 24 tiles de alto=192 pixeles del modo screen 2 



FINAL:
